import unittest


class PerformLowlevelParseRetBreakpointCreated(unittest.TestCase):
	def test_breakpoint_is_at_ret(self):
		breakpoint_loc = int(perform_lowlevel_parse_ret.location.lstrip("*"), 16)
		arch = gdb.selected_frame().architecture()
		disassembled_ins = arch.disassemble(breakpoint_loc)
		ins = disassembled_ins[0]['asm'].split(" ")[0]

		self.assertIn(ins, ["ret", "retq"])

	def test_not_pending(self):
		self.assertFalse(perform_lowlevel_parse_ret.pending)

class HPackratParseRetBreakpointCreated(unittest.TestCase):
	def test_breakpoint_is_at_ret(self):
		breakpoint_loc = int(h_packrat_parse_ret.location.lstrip("*"), 16)
		arch = gdb.selected_frame().architecture()
		disassembled_ins = arch.disassemble(breakpoint_loc)
		ins = disassembled_ins[0]['asm'].split(" ")[0]

		self.assertIn(ins, ["ret", "retq"])

	def test_not_pending(self):
		self.assertFalse(h_packrat_parse_ret.pending)
